
  member('test.clw')
  map
    module('md5.c')
      MD5Init(LONG),ULONG, RAW, NAME('_MD5Init')
      MD5Update(LONG, *STRING, UNSIGNED),ULONG, RAW, NAME('_MD5Update')
      MD5Final(*CSTRING, LONG),ULONG, RAW, NAME('_MD5Final')
    end

  end

GetMD5  PROCEDURE(s,dig)
!---------------------------------------------------------------
!Parmetro:
!  s *STRING: source para hacer el hash
!  d *STRING(32) donde retorna el hash
!
!---------------------------------------------------------------
CTE:BufferLen    EQUATE(64)

ctxPtr           LONG,AUTO
RetVal           LONG,AUTO
bufLen           LONG,AUTO
xStr             STRING('0123456789ABCDEF'),STATIC
xChr             STRING(1),DIM(16),OVER(xStr)
Digest           CSTRING(33),AUTO
ctx              GROUP
State              ULONG,DIM(4)                  !state (ABCD)
Count              ULONG,DIM(2)                  !number of bits, modulo 2^64 (lsb first)
MD5Buffer          BYTE,DIM(CTE:BufferLen)       !input buffer
                 END
  CODE
  ctxPtr = Address(ctx)
  RetVal = MD5Init(ctxPtr)
  bufLen = CTE:BufferLen
  n# = Len(s)
  i# = 1
  IF (n#-i#)+1 < CTE:BufferLen THEN bufLen = n# - i# + 1.
  RetVal = MD5Update(ctxPtr, s, bufLen)
  RetVal = MD5Final(Digest, ctxPtr)

  LOOP i# = 1 to 16                                     !Convert csDigest to Hexadecimal
    Dig[(i#-1)*2+1] = xChr[VAL(Digest[i#])/16+1]
    Dig[i#*2]       = xChr[VAL(Digest[i#])%16+1]
  END !loop
  RETURN
